#pragma once

#include "Things/TouchSensor.h"

namespace RoboidControl {
namespace Arduino {

/// @brief A digital input represents the stat of a digital GPIO pin
class DigitalInput : public TouchSensor {
 public:
  /// @brief Create a new digital input
  /// @param participant The participant to use
  /// @param pin The digital pin
  DigitalInput(Participant* participant, unsigned char pin);

  /// @copydoc RoboidControl::Thing::Update(unsigned long currentTimeMs)
  virtual void Update(unsigned long currentTimeMs,
                      bool recursive = false) override;

 protected:
  /// @brief The pin used for digital input
  unsigned char pin = 0;
};

}  // namespace Arduino
}  // namespace RoboidControl